/* 
 * File:   mainWidget.cpp
 * Autor: Strelok Vlad Kolerts
 *
 * Created on Martch 16, 2009, 2:19 AM
 */
#include <qtimer.h>

#include "mainWidget.h"
#include "resources.h"

extern util u;
extern QString kGetMime(const char*ChineseString);

mainWidget::mainWidget() : ZKbMainWidget(ZHeader::FULL_TYPE, NULL, "ZMainWidget", WType_Modal | WType_TopLevel)//	TIME_TYPE,	TINY_TYPE,	SMALL_TYPE,	FULL_TYPE
{
	QFont font("KolertsFont",14,25,false);
	setFont(font);
	
	fullInfo=0;
	
	resize(240,320);
	a->installEventFilter(this);
    setMainWidgetTitle(kGetFile(file));
	fullScreenModeChanged(false);
	
	w = new iWidget();

	QVBoxLayout* layout = getVBoxLayout();
	
	aia = new ZAppInfoArea(this,"",0);
	setTitleBarWidget(aia);
	
	browser = new ZListBox(this, 0, ZSkinService::clsZListBox1);
	browser->setFixedWidth(240);
	browser->setFont(font);
	ZScrollPanel* panel = new ZScrollPanel(this, "chWidget", 0, (ZSkinService::WidgetClsID)4);
	//panel->setVScrollBarMode(ZScrollPanel::AlwaysOff);
    //panel->setHScrollBarMode(ZScrollPanel::AlwaysOff);
	//panel->setFixedWidth(240);
	panel->addChild(browser,0,0);
	layout->addWidget(panel);

	QPixmap pm;
	QRect rect;
	menu = new ZOptionsMenu(rect, NULL, NULL, 0);
	exmenu = new ZOptionsMenu(rect, NULL, NULL, 0);
	
	exmenu->insertItem(UTF("Выделенное"), NULL, NULL, false, 0, 0);
	exmenu->insertItem(UTF("Весь архив"), NULL, NULL,true, 1, 1);
	
	exmenu->connectItem(0, this, SLOT(slot_extract()));
	exmenu->connectItem(1, this, SLOT(slot_extractAll()));
	
	//pm->load(work_folder+IDB_IMAGE_PASTE);
	//menu->insertItem("\t\t\t"+LANG_PASTE, NULL, pm, false, 3, 3);
	menu->insertItem(UTF("Открыть"), NULL, NULL, false, 0, 0);
	menu->insertItem(UTF("Распаковать"), exmenu, NULL,true, 1, 1);
	menu->insertItem(UTF("Инфо об архиве"), NULL, NULL, true, 2, 2);
	menu->insertSeparator ( 3, 3 );
	menu->insertItem(UTF("О программе"), NULL, NULL, true, 3, 3);
	menu->insertItem(UTF("Выход"), NULL, NULL, true, 4, 4);
	
	//menu->setItemEnabled(0, true);
	menu->connectItem(0, this, SLOT(slot_open()));
	//menu->connectItem(1, this, SLOT(slot_extractAll()));
	menu->connectItem(2, this, SLOT(slot_info()));
	menu->connectItem(3, this, SLOT(slot_about()));
	menu->connectItem(4, qApp, SLOT(quit()));
	
	softKey = new ZSoftKey(NULL, this, this);
	softKey->setText(ZSoftKey::LEFT, UTF("Опции"), (ZSoftKey::TEXT_PRIORITY) 0);
	softKey->setText(ZSoftKey::RIGHT, UTF("Выход"), (ZSoftKey::TEXT_PRIORITY) 0);
	softKey->setOptMenu(ZSoftKey::LEFT, menu);
	softKey->setClickedSlot(ZSoftKey::RIGHT, this, SLOT(slot_quit()));
    setSoftKey(softKey);
	
	connect(browser, SIGNAL(selected(int)), this, SLOT(selected(int)));
	
	if(u.fExist(file))
	{
		u.getType();
		u.readArc(dat, dat_c);
		
		if(dat_c)
		{
			if(type==0 || type==1 || type==2)
			{
				menu->setItemEnabled(0, true);
				exmenu->setItemEnabled(0, true);
			}
			readMimes();
			readPlugins();
			setDir("/");
		}
		else
			showNotyfi("Ошибка чтения архива", IDB_IMAGE_ERROR, "Error of reading archive", 0);
	}
	else
		showNotyfi("Файл не найден", IDB_IMAGE_ERROR, "Can't find archive", 0);
}

mainWidget::~mainWidget()
{
}

void mainWidget::setDir(QString p)
{
	Debug("setDir "+cd+path);
	path=p;
	aia->removeArea(ZAppInfoArea::ACTIVITY);
	aia->appendText(ZAppInfoArea::ACTIVITY, cd+path, "path");
	
	browser->clear();
	
	QFont font=browser->font();
	if(fullInfo)
		font.setPixelSize(13);
	else
		font.setPixelSize(15);
	browser->setItemFont(ZListBox::region2, font, true);
	browser->setItemFont(ZListBox::region2, font, false);
	
	QPixmap pm;
	
	if(path!="/")
	{
		ZListBoxItem* Item = new ZListBoxItem(browser, "%I%M");
		pm.load(work_dir+IDB_IMAGE_BACK);
		a->processEvents();
		Item->setPixmap(0, pm);
		Item->appendSubItem(1, "..", false, NULL);
		browser->insertItem(Item,-1,true);
	}
	for(int i=0; i<dat_c; i++)
	{
		if(path==dat[i].path)
		{
			ZListBoxItem* Item = new ZListBoxItem ( browser, "%I%M" );
			if(dat[i].dir)
				pm.load(work_dir+QString(IDB_IMAGE_DIR).arg(fullInfo));
			else
			{
				pm.load(work_dir+QString(IDB_IMAGE_FILE).arg(fullInfo));
				QString mime_;
				mime_=kGetMime(dat[i].name).upper();
				for (int j=0;j<mime_c;j++)
				{
					if(mime_==mimes[j].type)
					{
						pm.load(work_dir+QString("res/img/mime/%1/%2.png").arg(fullInfo).arg(mimes[j].pm));
					}
				}
			}
				
			Item->setPixmap(0, pm);
			Item->appendSubItem(1, dat[i].name, false, NULL);
			if(fullInfo)
			{
				QString info=dat[i].date;
				if(!dat[i].dir)
					info=dat[i].size+"\t\t\t"+info;
				Item->appendSubItem(1, info, false, NULL);
			}			
			browser->insertItem(Item,-1,true);
		}
	}
}

void mainWidget::upDir()
{
	if(path!="/")
	{
		int pos=path.findRev("/");
		if(pos==0)
			path="/";
		else
			path=path.left(pos);
		setDir(path);
	}
}

void mainWidget::readPlugins()
{
	plugin_struct tmp;
	QString temp_line;
	
	QFile file(work_dir+"/fm_plugins.cfg");
	if( file.open(IO_ReadOnly) )		
	{
		QTextStream stream( &file );			
		while(temp_line=stream.readLine())
		{
			tmp.id=atoi(temp_line.mid(0,2));
			tmp.type=atoi(temp_line.mid(3,1));
			tmp.name=temp_line.mid(5,100);
			
			plugins.push_back(tmp);
			plug_c++;
		}
		file.close();	
	}
}

void mainWidget::readMimes()
{
	mime_struct tmp;
	QString temp_line;
	mime_c=0;
	
	QFile file(work_dir+"/mime_types.cfg");
	if(file.open(IO_ReadOnly))		
	{
		QTextStream stream( &file );			
		while(temp_line=stream.readLine())
		{
			tmp.pm=atoi(temp_line.mid(0,3));
			tmp.app=atoi(temp_line.mid(4,2));
			tmp.type=temp_line.mid(7,20).upper();
			
			mimes.push_back(tmp);
			mime_c++;
		}
		file.close();
	}
}

void mainWidget::selected(int index)
{
	ZListBoxItem* listitem = browser->item(index);
	QString name=listitem->getSubItemText ( 1, 0, false );
	if(name=="..")
		upDir();
	else
	{
		for(int i=0;i<dat_c;i++)
		{
			if(name==dat[i].name)
			{
				if(dat[i].dir)
				{
					if(path.right(1)!="/")
						path+="/";
					path+=name;
					setDir(path);
				}
				else
					slot_open();
				continue;
			}
		}
	}
}

int mainWidget::curItem()
{
	ZListBoxItem* listitem = browser->item(browser->currentItem());
	QString name=listitem->getSubItemText ( 1, 0, false );
	if(name!="..")
	{
		for(int i=0;i<dat_c;i++)
		{
			if(name==dat[i].name)
			{
				return i;
				continue;
			}
		}
	}
	return 0;
}

void mainWidget::slot_open()
{
	bool ret=true;
	QString ff;
	ff=cd.right(cd.length()-1)+dat[curItem()].path+"/"+dat[curItem()].name;
	ff.replace(QString("//"), QString("/"));
	if(ff.left(1)=="/")
		ff.remove(0,1);
	QString fto=prog_dir+".temp/"+ff;
	
	showNotyfi("Открывается "+ff, IDB_OPEN_WITH, "Open "+ff, 0);
	
	if(!u.fExist(fto))
	{
		if(!u.exFromArc(dat[curItem()].path, dat[curItem()].name, true))
		{
			showNotyfi("Ошибка открытия", IDB_IMAGE_ERROR, "Error of opening", 2000);
			ret=false;
		}
	}
	if(ret)
	{
		bool mime_finded=false;
		QString mime;
		QFileInfo *fi = new QFileInfo(fto);
		if(fi->isFile() /*&& fi->isExecutable()*/)
		{
			mime=kGetMime(fto).upper();
			
			for (int i=0;i<mime_c;i++)
			{
				if(mime==mimes[i].type)
				{
					for(int j=0;j<plug_c;j++)
					{
						if(mimes[i].app==plugins[j].id)
						{
							if (plugins[j].type==0 or 2)	system(work_dir+"/plugins/"+plugins[j].name+"/"+plugins[j].name+" -d "+fto+"&");
							if (plugins[j].type==1 or 3)	system(plugins[j].name+" "+fto+"&");
						}
					}
					mime_finded=true;
				}
			}
			if (!mime_finded)
			{
				/*if(fi->isExecutable())
					system("exec "+fto+"&");
				else*/
					showNotyfi("Don`t known how to open", IDB_IMAGE_ERROR, "Don`t known how to open "+ff, 0);
			}
		}
		else
			showNotyfi("Not executable", IDB_IMAGE_ERROR, fto+" not executable", 0);
		
		QTimer::singleShot(2000, this, SLOT(slot_infoArea()));
	}
}

void mainWidget::slot_extract()
{
	showNotyfi("Обработка архива", IDB_OPEN_WITH, "Extracting", 0);
	if(u.exFromArc(dat[curItem()].path, dat[curItem()].name, false))
		showNotyfi("Успешно!", IDB_IMAGE_WARNING, "Sucessfully", 2000);
	else
		showNotyfi("Ошибка разархивирования", IDB_IMAGE_ERROR, "Error of extracting", 2000);
}

void mainWidget::slot_extractAll()
{
	showNotyfi("Обработка архива", IDB_OPEN_WITH, "Extracting", 0);
	u.exArc();
	showNotyfi("Операция завершена", IDB_IMAGE_WARNING, "Operation finish", 2000);
}

void mainWidget::slot_info()
{
	QFileInfo f(file);
	QString types[]={"TAR","TGZ","TBZ","RAR","ZIP","7Z"};
	QString	text="Файл: "+file;
			text+="\nТип архива: "+types[type];
			text+="\nРазмер: "+u.countSize(QString::number(f.size()));
			text+="\nВ архиве";
			text+="\nпапок: "+QString::number(dirs);
			text+=" | файлов: "+QString::number(files);
	w->Label->setText(UTF(text));
	w->show();
}

void mainWidget::slot_about()
{
	QString	text="Возможности:";
			text+="\n- автоопределение архивов: tgz, bz2, tar, rar, zip, 7z;";
			text+="\n- просмотр содержимого с подробностями и картинками привязанными к mime типу в FsMan'e;";
			text+="\n- в архивах tar разархивирование отдельных элементов;";
			text+="\n- в архивах tar запуск файлов прямо из архивов посредством плагинов FsMan по привязанным к ним типам mime;";
	w->Label->setText(UTF(text));
	w->show();
	/*delete w;
	w = NULL;*/
}

void mainWidget::slot_infoArea()
{
	aia->removeArea(ZAppInfoArea::ACTIVITY);
	aia->appendText(ZAppInfoArea::ACTIVITY, cd+path, "path");
}

void mainWidget::slot_quit()
{
	showNotyfi("Очистка временных файлов", IDB_OPEN_WITH, "Clear temp files", 0);
	u.clearTmp();
	a->quit();
}

void mainWidget::showNotyfi(QString text, QString pm, QString debug, int time)
{
	aia->removeArea(ZAppInfoArea::ACTIVITY);
	if(pm!="")
		aia->appendIcon(ZAppInfoArea::ACTIVITY, QPixmap(work_dir+pm), "");
	aia->appendText(ZAppInfoArea::ACTIVITY, UTF(text), "");
	Debug(debug);
	a->processEvents();
	if(time)
		QTimer::singleShot(time, this, SLOT(slot_infoArea()));
}
/// --------------------------------------------------------

void mainWidget::keyPressEvent ( QKeyEvent* k )	//keyReleaseEvent
{
	switch(k->key())
	{
		case 4146:
			upDir();
		break;
		
		case 35:
			fullInfo=!fullInfo;
			setDir(path);
		break;
	}
}

/*void mainWidget::keyReleaseEvent ( QKeyEvent* k )	//keyReleaseEvent
	{
	}*/
