/* 
 * File:   mainWidget.h
 * Author: Strelok Vlad Kolerts 2010
 */

#ifndef _MAINWIDGET_H
#define	_MAINWIDGET_H

#include <ZOptionsMenu.h>
#include <ZAppInfoArea.h>
#include <ZListBox.h>
#include "iWidget.h"
#include "util.h"

struct plugin_struct
{
	QString name;
	int id;
	int type;
};

struct mime_struct
{
	QString type;
	int app;
	int pm;
};

class mainWidget: public ZKbMainWidget
{
    Q_OBJECT
public:
    mainWidget();
    ~mainWidget();
	
	iWidget* w;
	
	ZListBox*		browser;
	ZAppInfoArea*	aia;
    ZOptionsMenu*	menu;
	ZOptionsMenu*	exmenu;
	ZSoftKey*		softKey;
	
	QString path;
	bool fullInfo;
	std::vector<file_structure> dat;
	std::vector<plugin_struct> plugins;
	std::vector<mime_struct> mimes;
	int dat_c, plug_c, mime_c;

	void setDir(QString p);
	void upDir();
	void readPlugins();
	void readMimes();
	void showNotyfi(QString text, QString pm, QString debug, int time);
	int curItem();

public slots:
	void selected(int);
	void slot_open();
	void slot_extract();
	void slot_extractAll();
	void slot_info();
	void slot_about();
	void slot_infoArea();
	void slot_quit();

protected:
    virtual void keyPressEvent(QKeyEvent* k);
	//virtual void keyReleaseEvent(QKeyEvent* k);
};


#endif	/* _mainWidget_H */
