/* 
 * File:   util.cpp
 * Author: tiho = rusiki
 * 
 * Created on February 14, 2009, 2:22 AM
 */

#include "util.h"
#include <qfileinfo.h>

#define TAR_READ		"tar tvf %1"
#define TGZ_READ		"tar tvfz %1"
#define TBZ_READ		"tar tvfj %1"
#define ZIP_READ		"unzip -l %1"
#define RAR_READ		"unrar v %1"
#define Z7_READ			"7zr l %1"

#define TAR_EX		"tar xf %1 -C %2"
#define TGZ_EX		"tar xfz %1 -C %2"
#define TBZ_EX		"tar xfj %1 -C %2"
#define ZIP_EX		"unzip -o %1 -d %2"
#define RAR_EX		"unrar -y x %1 %2"
#define Z7_EX		"7zr -y x %1 -o%2"

#define TAR_EXFROM		"tar xvf %1 -C %2 %3"	//arc pathTo pathInArc
#define TGZ_EXFROM		"tar xvfz %1 -C %2 %3"
#define TBZ_EXFROM		"tar xvfj %1 -C %2 %3"
#define ZIP_EXFROM		"unzip -l %1"
#define RAR_EXFROM		"unrar v %1"
#define Z7_EXFROM		"7zr l %1"

extern QString kGetPath(const char*ChineseString);

util::util()
{
}

bool util::fExist(const QString &fpath)
{
    QFileInfo f(fpath);
    if (f.exists())
        return true;
    else
        return false;
}

void util::getType()
{
	type=0;
	QFile f(file);
	if( f.open(IO_ReadOnly) )		
	{
		QDataStream stream( &f );
		char* s = new char[6];
		stream.readRawBytes(s, 6);
		if		(s[0]==31	&& s[1]==139	&& s[2]==8)													type=1;
		if		(s[0]==66	&& s[1]==90		&& s[2]==104	&& s[3]==57		&& s[4]==49	&& s[5]==65)	type=2;
		else if	(s[0]==82	&& s[1]==97		&& s[2]==114	&& s[3]==33		&& s[4]==26	&& s[5]==7) 	type=3;
		else if	(s[0]==80	&& s[1]==75		&& s[2]==3		&& s[3]==4)									type=4;
		else if	(s[0]==55	&& s[1]==122	&& s[2]==188	&& s[3]==175	&& s[4]==39	&& s[5]==28)	type=5;
		//type=1	31	139	8	0
		//type=2	82	97	114	33	26	7	0
		//type=3	80	75	3	4
		//type=4	55	122 188	175	39	28	0
		f.close();
	}
}

void util::exArc()
{
	QString dest=kGetPath(file);
	switch(type)
	{
		case 0:
			Debug("UnTAR");
			exTAR(dest); //tar
		break;
		case 1:
			Debug("UnTGZ");
			exTAR(dest); //tgz
		break;
		case 2:
			Debug("UnTBZ2");
			exTAR(dest); //tbz
		break;
		case 3:
			Debug("UnRAR");
			exRAR(dest);
		break;
		case 4:
			Debug("UnZIP");
			exZIP(dest);
		break;
		case 5:
			Debug("Un7Z");
			ex7Z(dest);
		break;
	}
}
void util::exTAR(QString dest)
{
	QString cmd;
	if(type==1)
		cmd=QString(TGZ_EX).arg(file).arg(dest);
	else if(type==2)
		cmd=QString(TBZ_EX).arg(file).arg(dest);
	else
		cmd=QString(TAR_EX).arg(file).arg(dest);
	Debug(cmd);
	system(cmd);
}
void util::exZIP(QString dest)
{
	QString cmd=QString(ZIP_EX).arg(file).arg(dest);
	Debug(cmd);
	system(cmd);
}
void util::exRAR(QString dest)
{
	QString cmd=QString(RAR_EX).arg(file).arg(dest);
	Debug(cmd);
	system(cmd);
}
void util::ex7Z(QString dest)
{
	QString cmd=QString(Z7_EX).arg(file).arg(dest);
	Debug(cmd);
	system(cmd);
}
/*
#define TAR_EX		"tar xf %1 -C %2"
#define TGZ_EX		"tar xfz %1 -C %2"
#define TBZ_EX		"tar xfj %1 -C %2"
#define ZIP_EX		"unzip %1 -d %2"
#define RAR_EX		"unrar x %1 %2"
#define Z7_EX		"7zr x %1 %2"

#define TAR_EXFROM		"tar xvf %1 -C %2 %3"	//arc pathTo pathInArc*/

///	----------------------------------------------------------------------------------

bool util::exFromArc(QString p, QString f, bool tmp)
{
	QString ff;
	ff=cd.right(cd.length()-1)+p+"/"+f;
	ff.replace(QString("//"), QString("/"));
	if(ff.left(1)=="/")
		ff.remove(0,1);
	
	switch(type)
	{
		case 0:
			Debug("UnTAR");
			exFromTAR(ff); //tar
		break;
		case 1:
			Debug("UnTGZ");
			exFromTAR(ff); //tgz
		break;
		case 2:
			Debug("UnTBZ2");
			exFromTAR(ff); //tbz
		break;
		case 3:
			Debug("UnRAR");
			exFromRAR(ff);
		break;
		case 4:
			Debug("UnZIP");
			exFromZIP(ff);
		break;
		case 5:
			Debug("Un7Z");
			exFrom7Z(ff);
		break;
	}
	
	if(!tmp)
	{
		system(QString("mv %1 %2").arg(prog_dir+".temp/"+ff).arg(kGetPath(file)+f));
		
		if(fExist(kGetPath(file)+f))
			return true;
		else
			return false;
	}
	else
	{
		if(fExist(prog_dir+".temp/"+ff))
			return true;
		else
			return false;
	}
}
void util::exFromTAR(QString ff)
{
	QString cmd;
	if(type==1)
		cmd=QString(TGZ_EXFROM).arg(file).arg(prog_dir+".temp").arg(ff);
	else if(type==2)
		cmd=QString(TBZ_EXFROM).arg(file).arg(prog_dir+".temp").arg(ff);
	else
		cmd=QString(TAR_EXFROM).arg(file).arg(prog_dir+".temp").arg(ff);
	Debug(cmd);
	system(cmd);
}
void util::exFromZIP(QString ff)
{
	QString cmd=QString(ZIP_EXFROM).arg(file).arg(prog_dir+".temp").arg(ff);
	Debug(cmd);
	system(cmd);
}
void util::exFromRAR(QString ff)
{
	QString cmd=QString(RAR_EXFROM).arg(file).arg(prog_dir+".temp").arg(ff);
	Debug(cmd);
	system(cmd);
}
void util::exFrom7Z(QString ff)
{
	QString cmd=QString(Z7_EXFROM).arg(file).arg(prog_dir+".temp").arg(ff);
	Debug(cmd);
	system(cmd);
}

///	----------------------------------------------------------------------------------

void util::readArc(std::vector<file_structure> &dat, int &dat_c)
{
	dat.clear();dat_c=0;cd="";
	switch(type)
	{
		case 0:
			Debug("ReadTAR");
			readTAR(dat, dat_c); //tar
		break;
		case 1:
			Debug("ReadTGZ");
			readTAR(dat, dat_c); //tgz
		break;
		case 2:
			Debug("ReadTBZ2");
			readTAR(dat, dat_c); //tbz
		break;
		case 3:
			Debug("ReadRAR");
			readRAR(dat, dat_c);
		break;
		case 4:
			Debug("ReadZIP");
			readZIP(dat, dat_c);
		break;
		case 5:
			Debug("Read7Z");
			read7Z(dat, dat_c);
		break;
	}
	if(dat_c)
	{
		pathChk(dat, dat_c);
		resort(dat, dat_c);
	}
}

void util::readTAR(std::vector<file_structure> &dat, int &dat_c)
{
	file_structure tmp;
	string cmd;
	if(type==1)
		cmd=std::string(QString(TGZ_READ).arg(file));
	else if(type==2)
		cmd=std::string(QString(TBZ_READ).arg(file));
	else
		cmd=std::string(QString(TAR_READ).arg(file));

	redi::pstream entrys(cmd); //bin/busybox tar zxvf /mmc/mmca1/1.tgz -C /mmc/mmca1/ zxmms/zxmms.png 

	string tmp_;	QString text;	int i=0;
	while (entrys >> tmp_)
	{
		text=QString(tmp_.c_str());
		switch(i)
		{
			case 0:
				if(text.left(1)=="d")
					tmp.dir=true;
				else
					tmp.dir=false;
			break;
			case 2:
				if(!tmp.dir)
					tmp.size=countSize(text);
			break;
			case 3:
				tmp.date=" "+text;
			break;
			case 5:
				if(tmp.dir)
					text=text.left(text.length()-1);
				int i = text.findRev("/");
				if(i!=-1)
				{
					tmp.name=text.right(text.length()-i-1);
					tmp.path="/"+text.left(i);
				}
				else
				{
					tmp.name=text;
					tmp.path="/";
				}
			break;
		}
		i++;
		if(i>5)
		{
			i=0;
			if(tmp.name!="")
			{
				dat.push_back(tmp);
				dat_c++;
			}
		}
	}
	if(dat_c)
	{
		if(dat[0].path!="/")
		{
			tmp.name=dat[0].path.right(dat[0].path.length()-1);
			tmp.path="/";
			tmp.date=dat[0].date;
			tmp.dir=true;
			dat.push_back(tmp);
			dat_c++;
		}
	}
}

void util::readRAR(std::vector<file_structure> &dat, int &dat_c)
{
	file_structure tmp;bool finish=false;
	string cmd;
	cmd=std::string(QString(RAR_READ).arg(file));

	redi::pstream entrys(cmd);

	string tmp_;	QString text;	int i=0;
	for(int j=0;j<23;j++)
	{
		entrys >> tmp_;
	}
	while (entrys >> tmp_ && !finish)
	{
		text=QString(tmp_.c_str());
		if(text=="-------------------------------------------------------------------------------")
		{
			finish=true;
			break;
		}
		if(i==0)
		{
			int i = text.findRev("/");
			if(i!=-1)
			{
				tmp.name=text.right(text.length()-i-1);
				tmp.path="/"+text.left(i);
			}
			else
			{
				tmp.name=text;
				tmp.path="/";
			}
		}
		else if(i==1)
			tmp.size=countSize(text);
		else if(i==4)
			tmp.date=" "+text;
		else if(i==6)
		{
			if(text.left(2)==".D")
				tmp.dir=true;
			else
				tmp.dir=false;
		}
		
		i++;
		if(i>9)
		{
			i=0;
			if(tmp.name!="")
			{
				dat.push_back(tmp);
				dat_c++;
			}
		}
	}
}

void util::readZIP(std::vector<file_structure> &dat, int &dat_c)
{
	file_structure tmp;
	string cmd;bool finish=false;
	cmd=std::string(QString(ZIP_READ).arg(file));

	redi::pstream entrys(cmd);

	string tmp_;	QString text;	int i=0;
	for(int j=0;j<10;j++)
	{
		entrys >> tmp_;
	}
	while (entrys >> tmp_ && !finish)
	{
		text=QString(tmp_.c_str());
		if(text=="--------")
		{
			finish=true;
			break;
		}
		switch(i)
		{
			case 0:
				tmp.size=countSize(text);
			break;
			case 1:
				tmp.date=" "+text;
			break;
			case 3:
				if(text.right(1)=="/")
					tmp.dir=true;
				else
					tmp.dir=false;
				if(tmp.dir)
					text=text.left(text.length()-1);
				int i = text.findRev("/");
				if(i!=-1)
				{
					tmp.name=text.right(text.length()-i-1);
					tmp.path="/"+text.left(i);
				}
				else
				{
					tmp.name=text;
					tmp.path="/";
				}
			break;
		}
		i++;
		if(i>3)
		{
			i=0;
			if(tmp.name!="")
			{
				dat.push_back(tmp);
				dat_c++;
			}
		}
	}
}

void util::read7Z(std::vector<file_structure> &dat, int &dat_c)
{
	file_structure tmp;bool finish=false;
	string cmd;

	cmd=std::string(QString(Z7_READ).arg(file));

	redi::pstream entrys(cmd); //bin/busybox tar zxvf /mmc/mmca1/1.tgz -C /mmc/mmca1/ zxmms/zxmms.png 

	string tmp_;	QString text;	int i=0;
	for(int j=0;j<29;j++)
	{
		entrys >> tmp_;
	}
	while (entrys >> tmp_ && !finish)
	{
		text=QString(tmp_.c_str());
		if(text=="-------------------")
		{
			finish=true;
			break;
		}
		//qDebug(text);
		switch(i)
		{
			case 0:
				tmp.date=" "+text;
			break;
			case 2:
				if(text.left(1)=="D")
					tmp.dir=true;
				else
					tmp.dir=false;
			break;
			case 3:
				if(!tmp.dir)
					tmp.size=countSize(text);
			break;
			case 5:
				int i = text.findRev("/");
				if(i!=-1)
				{
					tmp.name=text.right(text.length()-i-1);
					tmp.path="/"+text.left(i);
				}
				else
				{
					tmp.name=text;
					tmp.path="/";
				}
				qDebug(tmp.name+" "+tmp.path);
			break;
		}
		i++;
		if(i>5)
		{
			i=0;
			if(tmp.name!="")
			{
				dat.push_back(tmp);
				dat_c++;
			}
		}
	}
	if(dat_c)
	{
		if(dat[0].path!="/")
		{
			tmp.name=dat[0].path.right(dat[0].path.length()-1);
			tmp.path="/";
			tmp.date=dat[0].date;
			tmp.dir=true;
			dat.push_back(tmp);
			dat_c++;
		}
	}
}

///	----------------------------------------------------------------------------------

void util::pathChk(std::vector<file_structure> &dat, int &dat_c)
{
	if(dat[0].path.find("/")!=dat[0].path.findRev("/"))//dat[0].path.left(1)!="/"
	{
		cd=dat[0].path;
		for(int i=0;i<dat_c;i++)
		{
			dat[i].path=dat[i].path.remove(0, cd.length());
			if(dat[i].path=="")
				dat[i].path="/";
		}
	}
}

QString util::countSize(QString siz)
{
	double size=atoi(siz);
	if (size < 1024)
		return QString("%1 b").arg(size);
	else if (size < 1024 * 1024)
		return QString("%1 Kb").arg(floor(size/1024*100)/100);///(double)
	else
		return QString("%1 Mb").arg(floor(size/1024/1024*100)/100);///(double)
}

void util::resort(std::vector<file_structure> &dat, int &dat_c)
{
	std::vector<file_structure> tmp;
	tmp=dat;
	dat.clear();
	dirs=files=0; 
	for(int i=0;i<dat_c;i++)
	{
		if(tmp[i].dir)
		{
			dat.push_back(tmp[i]);
			dirs++;
		}
	}
	for(int i=0;i<dat_c;i++)
	{
		if(!tmp[i].dir)
		{
			dat.push_back(tmp[i]);
			files++;
		}
	}
}

void util::clearTmp()
{
	system(QString("rm -f -r %1").arg(prog_dir+".temp/"));
	QDir dir;
	dir.setPath(prog_dir);
	dir.mkdir(".temp", false);
}

util::~util() {
}

