/* 
 * File:   util.h
 * Author: tiho = rusiki
 *
 * Created on February 14, 2009, 2:22 AM
 */

#ifndef _UTIL_H
#define	_UTIL_H

#include "QDaemonApp.h"
#include <qtextstream.h>
#include <qdatastream.h>
#include <qdir.h>
#include <qfile.h>
#include "pstream.h"
#include <vector>
#include <string>
using namespace std;

struct file_structure
{
	QString name;
	QString path;
	QString date;
	QString size;
	bool dir;
};
extern QString UTF( const char*ChineseString );
extern QString kGetFile(const char*ChineseString);

extern QDaemonApp* a;
extern QString work_dir, prog_dir, file, cd;
extern void Debug(QString text);
extern int files, dirs;
extern int type;

class util {
public:
	util();
	~util();

	void getType();
	
	void exArc();
	void exTAR(QString dest);
	void exZIP(QString dest);
	void exRAR(QString dest);
	void ex7Z(QString dest);
	
	bool exFromArc(QString p, QString f, bool tmp);
	void exFromTAR(QString ff);
	void exFromZIP(QString ff);
	void exFromRAR(QString ff);
	void exFrom7Z(QString ff);
	
	void readArc(std::vector<file_structure> &dat, int &dat_c);
	void readTAR(std::vector<file_structure> &dat, int &dat_c);
	void readZIP(std::vector<file_structure> &dat, int &dat_c);
	void readRAR(std::vector<file_structure> &dat, int &dat_c);
	void read7Z(std::vector<file_structure> &dat, int &dat_c);
	
	QString countSize(QString siz);
	void resort(std::vector<file_structure> &dat, int &dat_c);
	void pathChk(std::vector<file_structure> &dat, int &dat_c);

	bool fExist(const QString &fpath);
	
	void clearTmp();
};

#endif	/* _UTIL_H */

